Subversion Repositories QNX 8.QNX8 GNU binutils

Rev

Rev 8 | Rev 11 | Go to most recent revision | Blame | Compare with Previous | Last modification | View Log | Download | RSS feed

  1. #!/bin/sh
  2. # GNU binutils toolchain cross-compilation script for QNX 8.0 by Pierre-Marie Baty <pm@pmbaty.com>
  3.  
  4. # NOTE TO SELF: DO NOT USE $0 AS THIS SCRIPT CAN BE RUN *OR* SOURCED! (see build-llvm.sh in the VM)
  5.  
  6. export QNXSDK_VERSION="8.0.0" # version of the QNX SDK in use, in <major>.<minor>.<revision> format
  7. export QNXSDK_PATH="../qnx800" # relative location from the path of this script where to find the QNX platform SDK
  8. export QNXSDK_HOSTPATH="host/linux/x86_64" # relative location in QNXSDK_PATH of the tree containing the build tools that are runnable on the build host
  9. export QNXSDK_TARGETPATH="target/qnx" # relative location in QNXSDK_PATH of the tree containing the QNX8 system header files
  10.  
  11. export BUILD_DIR_NAME="binutils-build" # name of the directory on the build host's desktop where the GNU binutils sources will be built
  12. export BUILD_TARGET_ARCHS="x86_64 aarch64" # space-separated list of CPU architectures to build the GNU binutils for, among "x86_64" and "aarch64"
  13.  
  14. export BINUTILS_VERSION="2.41" # version of GNU binutils that will be built. Should match the Win32 and Linux tools.
  15.  
  16. export BINUTILS_SOURCES_FILE="binutils-${BINUTILS_VERSION}.tar.gz" # name of the file containing GNU binutils version BINUTILS_VERSION sources
  17. export BINUTILS_SOURCES_URL="https://ftp.gnu.org/gnu/binutils/${BINUTILS_SOURCES_FILE}" # download URL of BINUTILS_SOURCES_FILE
  18. export BINUTILS_SOURCES_DIR="binutils-${BINUTILS_VERSION}" # name of directory created when extracting BINUTILS_SOURCES_FILE
  19.  
  20. export REQUIRED_TOOLS="wget python3 gcc g++ make m4" # list of build tools required to build all this on the build host
  21.  
  22. # see where we are
  23. export CURRENT_DIR="$(pwd)"
  24.  
  25. print_error_and_die()
  26. {
  27.         # a handy function that does what it says. Args: error strings to print, one line per argument
  28.         test -z "${COLUMNS}" && COLUMNS=80
  29.         echo ""
  30.         while [ -n "${1}" ]; do
  31.                 echo "${1}"|fold -s -w "${COLUMNS}"
  32.                 shift
  33.         done
  34.         echo ""
  35.         exit 1
  36. }
  37.  
  38. # verify we're a x86_64 Linux host
  39. if [ ! "$(uname)" = "Linux" ] || [ ! "$(uname -m)" = "x86_64" ]; then
  40.         print_error_and_die "Error: this script requires a x86_64 Linux machine (possibly a virtual machine) as the build host."
  41. fi
  42.  
  43. # verify that we have the QNX platform SDK
  44. if [ ! -d "${QNXSDK_PATH}/${QNXSDK_HOSTPATH}" ] || [ ! -d "${QNXSDK_PATH}/${QNXSDK_TARGETPATH}" ]; then
  45.         # host tools not deployed, do they exist in the form of a packed archive ? if so, extract it in place
  46.         if [ -f "${QNXSDK_PATH}/host/linux.tar.gz" ]; then
  47.                 cd "${QNXSDK_PATH}/host"
  48.                 echo "Deploying QNX SDP Linux host tools, please wait..."
  49.                 tar xzf "linux.tar.gz" || exit 1
  50.                 cd "${CURRENT_DIR}"
  51.         fi
  52.         # now test again
  53.         if [ ! -d "${QNXSDK_PATH}/${QNXSDK_HOSTPATH}" ] || [ ! -d "${QNXSDK_PATH}/${QNXSDK_TARGETPATH}" ]; then
  54.                 print_error_and_die "Error: the ${QNXSDK_PATH} path doesn't contain a QNX SDK. It must contain the 'host' and 'target' directories of the QNX SDP for the targeted version of QNX and the ${BUILD_TARGET_ARCH} platform. Please deploy these directories and try again."
  55.         fi
  56. fi
  57.  
  58. # verify that we have the required tools
  59. for REQUIRED_TOOL in ${REQUIRED_TOOLS}; do
  60.         "${REQUIRED_TOOL}" --version > /dev/null 2>&1 || print_error_and_die \
  61.                 "Error: this script requires at the very least the following tools installed:" \
  62.                 "       $(echo "${REQUIRED_TOOLS}"|sed 's/ /\n  /g')" \
  63.                 "Please install them (possibly as binary packages with apt-get) and try again." \
  64.                 "More specifically, the following tool was not found: '${REQUIRED_TOOL}'"
  65. done
  66.  
  67. # verify that the symlinks are deployed in the SDK -- just test one of them
  68. if [ ! -e "${QNXSDK_PATH}/${QNXSDK_TARGETPATH}/usr/include/readline.h" ]; then
  69.         print_error_and_die \
  70.                 "Error: the toolchain platform-specific symbolic links have not been deployed in this QNX SDK. Please run" \
  71.                 "(on a POSIX machine:)" \
  72.                 "       cd ${QNXSDK_PATH}" \
  73.                 "       find . -name symlinks.lst -exec ./symlinks.sh {} create \\; && printf 'present' > .symlinks-state" \
  74.                 "(else on a Windows machine:)" \
  75.                 "       cd ${QNXSDK_PATH}" \
  76.                 "       host\\win64\\x86_64\\usr\\bin\\busybox.exe sh -c \"find . -name symlinks.lst -exec ./symlinks.sh {} create \\; && printf 'present' > .symlinks-state\"" \
  77.                 "Note that this step WILL take time on a Win32 machine, but is only done once."
  78. fi
  79.  
  80. # create a symlink in /tmp that will lead to the QNX platform SDK so as to avoid spaces in paths if it doesn't exist already
  81. # (this is totally prohibitive with the official QNX toolchain)
  82. if [ ! -L /tmp/qnxsdk ] || [ ! "$(readlink /tmp/qnxsdk)" = "$(realpath "${CURRENT_DIR}/${QNXSDK_PATH}")" ]; then
  83.         echo "Creating symlink to QNX toolchain in /tmp/qnxsdk..."
  84.         rm -rf /tmp/qnxsdk 2>/dev/null
  85.         ln -fs "$(realpath "${CURRENT_DIR}/${QNXSDK_PATH}")" /tmp/qnxsdk || exit 1
  86. fi
  87.  
  88. # setup the environment
  89. export QNX_HOST="/tmp/qnxsdk/${QNXSDK_HOSTPATH}"
  90. export QNX_TARGET="/tmp/qnxsdk/${QNXSDK_TARGETPATH}"
  91. export MAKEFLAGS="-I${QNX_TARGET}/usr/include"
  92. export PATH="${QNX_HOST}/usr/bin:${PATH}"
  93.  
  94. # print the build environment
  95. echo "QNX_HOST=${QNX_HOST}"
  96. echo "QNX_TARGET=${QNX_TARGET}"
  97. echo "MAKEFLAGS=${MAKEFLAGS}"
  98.  
  99. # change to an immediately visible path, i.e. the user's desktop (failsafe to $HOME if xdg-user-dir is unavailable)
  100. STAGING_PATH="$(xdg-user-dir DESKTOP 2>/dev/null || echo "${HOME}")"
  101. cd "${STAGING_PATH}"
  102.  
  103. # download the involved source packages and unpack them if not done yet
  104. download_and_unpack_if_necessary()
  105. {
  106.         # helper function that downloads a sources tarball, extracts it and patches it if necessary
  107.         # args: <sources dirname> <sources filename> <download URL> [optional patchset URL]
  108.         test -d "${1}" && return 0 # if sources directory already exists, nothing to do
  109.         if [ ! -s "${CURRENT_DIR}/${2}" ]; then # if sources archive isn't a nonempty file...
  110.                 echo "Downloading ${1} sources from ${3}..."
  111.                 if ! wget -O "${CURRENT_DIR}/${2}" "${3}"; then
  112.                         # remove output file in case an error occurs
  113.                         rm -f "${CURRENT_DIR}/${2}"
  114.                         exit 1
  115.                 fi
  116.         fi
  117.         echo "Extracting ${1} sources..."
  118.         cd "$(dirname "${1}")"
  119.         if echo "${2}"|grep -q "\.tar\.bz2$"; then
  120.                 # BZip2 tarball
  121.                 tar xjf "${CURRENT_DIR}/${2}" || exit 1
  122.         elif echo "${2}"|grep -q "\.tar\.xz$"; then
  123.                 # XZ tarball
  124.                 tar xJf "${CURRENT_DIR}/${2}" || exit 1
  125.         elif echo "${2}"|grep -q "\.tar\.gz$"; then
  126.                 # GZipped tarball
  127.                 tar xzf "${CURRENT_DIR}/${2}" || exit 1
  128.         else
  129.                 echo "Error: unsupported file extension. Please improve the download_and_unpack_if_necessary() shell function to support it."
  130.                 exit 1
  131.         fi
  132.         # make sure the expected directory is here after extraction
  133.         if [ ! -d "${1}" ]; then
  134.                 echo "Error: couldn't find ${1} in extracted sources."
  135.                 exit 1
  136.         fi
  137.         # do we have a patchset to apply ?
  138.         if [ -n "${4}" ]; then
  139.                 echo "Downloading ${1} patchset from ${4}..."
  140.                 wget -O "${CURRENT_DIR}/${2}.patchset" "${4}" || exit 1
  141.                 echo "Applying patchset..."
  142.                 OLDDIR="$(pwd)"
  143.                 cd "${1}"
  144.                 patch -N -Z -p1 < "${CURRENT_DIR}/${2}.patchset" || exit 1
  145.                 cd "${OLDDIR}"
  146.                 unset OLDDIR
  147.         fi
  148.         return 0
  149. }
  150. download_and_unpack_if_necessary "${BINUTILS_SOURCES_DIR}" "${BINUTILS_SOURCES_FILE}" "${BINUTILS_SOURCES_URL}" || exit 1
  151.  
  152. # change directory to the binutils sources
  153. cd "${BINUTILS_SOURCES_DIR}" || exit 1
  154.  
  155. backup_and_patch_if_necessary()
  156. {
  157.         # handy function that patches a file in the current directory with a given sed replacement regex if necessary, creating backups
  158.         # args: <file pathname> <grep_string_to_test_for_presence_of_patch> <sed regex>
  159.         _PATCHEE_PATHNAME="${1}"
  160.         _PATCHED_PATTERN="${2}"
  161.         # test if already patched
  162.         grep -q "${_PATCHED_PATTERN}" "${_PATCHEE_PATHNAME}" && return
  163.         # tell what we're about to do
  164.         echo "Patching ${_PATCHEE_PATHNAME}..."
  165.         _DOTTED_NAME="$(echo "${_PATCHEE_PATHNAME}"|tr '/' '.')"
  166.         # have a backup first
  167.         test -f "${CURRENT_DIR}/${_DOTTED_NAME} [ORIGINAL]" || cp "${_PATCHEE_PATHNAME}" "${CURRENT_DIR}/${_DOTTED_NAME} [ORIGINAL]" || exit 1
  168.         # perform the patch
  169.         cp -f "${CURRENT_DIR}/${_DOTTED_NAME} [ORIGINAL]" "${CURRENT_DIR}/${_DOTTED_NAME} [PATCHED]" || exit 1
  170.         while [ -n "${3}" ]; do
  171.                 sed -E -i "${3}" "${CURRENT_DIR}/${_DOTTED_NAME} [PATCHED]"
  172.                 shift
  173.         done
  174.         # verify that we did it successfully
  175.         if ! grep -q "${_PATCHED_PATTERN}" "${CURRENT_DIR}/${_DOTTED_NAME} [PATCHED]"; then
  176.                 echo "Error: the file ${_PATCHEE_PATHNAME} could not be patched. Please investigate and fix manually." | fold -s -w 79; exit 1
  177.         fi
  178.         # and put the patched file in place
  179.         cp -f "${CURRENT_DIR}/${_DOTTED_NAME} [PATCHED]" "${_PATCHEE_PATHNAME}" || exit 1
  180. }
  181. backup_and_replace()
  182. {
  183.         # handy function that replaces a file in the current directory with a given replacement, creating backups
  184.         # args: <file pathname> <replacement pathname>
  185.         # tell what we're about to do
  186.         echo "Replacing ${1}..."
  187.         # have a backup first
  188.         test -f "${CURRENT_DIR}/$(echo "${1}"|tr '/' '.') [ORIGINAL]" || test -e "${1}" && cp "${1}" "${CURRENT_DIR}/$(echo "${1}"|tr '/' '.') [ORIGINAL]"
  189.         # perform the replacement
  190.         cp -f "${2}" "${1}" || exit 1
  191. }
  192.  
  193. # patch libiberty/pex-unix.c
  194. # replace:
  195. #       defined(HAVE_SPAWNVE)
  196. # with:
  197. #       !defined(__QNXNTO__) && defined(HAVE_SPAWNVE)
  198. # RATIONALE: QNX exposes the same spawnve() functions which were invented by Microsoft. Autoconf mistakenly believes it's a Cygwin system.
  199. # Moreover the flags _P_NOWAIT and _P_NOWAITO don't have the same meaning on QNX: the second one doesn't create zombies waiting for their exit
  200. # status to be read, whereas on Microsoft they're the same. This prevents process created with this flag (as libiberty does) from being wait()ed.
  201. # Fix that by declaring that we want to use the traditional POSIX fork/exec scheme, which QNX supports as well.
  202. backup_and_patch_if_necessary "libiberty/pex-unix.c" __QNXNTO__ \
  203.         's@defined\(HAVE_SPAWNVE\)@\!defined\(__QNXNTO__\) \&\& defined\(HAVE_SPAWNVE\)@g'
  204.  
  205. # patch bfd/config.bfd
  206. # RATIONALE: insert x86_64 and aarch64 QNX definitions for the BFD library
  207. backup_and_replace "bfd/config.bfd" "${CURRENT_DIR}/bfd.config.bfd"
  208.  
  209. # patch ld/configure.tgt
  210. # RATIONALE: insert x86_64 and aarch64 QNX definitions for the GNU linker
  211. backup_and_replace "ld/configure.tgt" "${CURRENT_DIR}/ld.configure.tgt"
  212.  
  213. # patch ld/emulparams/aarch64nto.sh
  214. # RATIONALE: insert aarch64 QNX particularities for the GNU linker
  215. backup_and_replace "ld/emulparams/aarch64nto.sh" "${CURRENT_DIR}/ld.emulparams.aarch64nto.sh"
  216.  
  217. # patch ld/emulparams/elf_x86_64nto.sh
  218. # RATIONALE: insert aarch64 QNX particularities for the GNU linker
  219. backup_and_replace "ld/emulparams/elf_x86_64.sh" "${CURRENT_DIR}/ld.emulparams.elf_x86_64.sh"
  220.  
  221. # define the tools to use when compiling intermediary programs on the build host
  222. export AR_FOR_BUILD="/usr/bin/ar"
  223. export AS_FOR_BUILD="/usr/bin/as"
  224. export LD_FOR_BUILD="/usr/bin/ld"
  225. export NM_FOR_BUILD="/usr/bin/nm"
  226. export RANLIB_FOR_BUILD="/usr/bin/ranlib"
  227. export CC_FOR_BUILD="/usr/bin/gcc"; CFLAGS_FOR_BUILD="-fuse-ld=${LD_FOR_BUILD}"
  228. export CXX_FOR_BUILD="/usr/bin/g++"; CXXFLAGS_FOR_BUILD="-fuse-ld=${LD_FOR_BUILD}"
  229.  
  230. # now, for each target arch the native binutils should support...
  231. for BUILD_TARGET_ARCH in ${BUILD_TARGET_ARCHS}; do
  232.  
  233.         # construct the target triple (actually a quadruple)
  234.         TARGET_ARCH="${BUILD_TARGET_ARCH}"
  235.         test "${BUILD_TARGET_ARCH}" = "x86_64" && TARGET_VENDOR="pc" || TARGET_VENDOR="unknown"
  236.         TARGET_KERNEL="nto"
  237.         TARGET_SYSTEM="qnx${QNXSDK_VERSION}"
  238.         export TARGET_TRIPLE="${TARGET_ARCH}-${TARGET_VENDOR}-${TARGET_KERNEL}-${TARGET_SYSTEM}"
  239.         echo "Will build for ${TARGET_TRIPLE}"
  240.  
  241.         # create the build directory
  242.         echo "Wiping out build directory..."
  243.         test -e ".build/${TARGET_TRIPLE}" && rm -rf ".build/${TARGET_TRIPLE}"
  244.         mkdir -p ".build/${TARGET_TRIPLE}" || exit 1
  245.         ln -fs "${BINUTILS_SOURCES_DIR}/.build" "../${BUILD_DIR_NAME}"
  246.         cd ".build/${TARGET_TRIPLE}"
  247.  
  248.         # configure and build the GNU binutils. Note that since these are low level tools, we want static binaries as much as possible.
  249.         # NOTE: in this context, --host means the machine the built program is expected to RUN on, and --target the machine the built program will FOCUS on.
  250.         ../../configure \
  251.                         --with-sysroot="${QNX_TARGET}" \
  252.                 --prefix="$(dirname "$(dirname "${QNX_HOST}")")/qnx$(echo "${QNXSDK_VERSION}"|awk -F. '{print $1}')/${BUILD_TARGET_ARCH}/usr" \
  253.                --host="x86_64-pc-nto-qnx${QNXSDK_VERSION}" \
  254.                --target="${TARGET_TRIPLE}" \
  255.                --disable-shared \
  256.                --disable-nls \
  257.                --enable-static-link \
  258.                --disable-shared-plugins \
  259.                --disable-dynamicplugin \
  260.                --disable-pie \
  261.                --enable-static=yes \
  262.                --enable-shared=no \
  263.                         --enable-threads \
  264.                         --disable-bootstrap \
  265.                --disable-doc || exit 1
  266.  
  267.         # and build the whole shit
  268.         make -j 4 MAKEINFO=/bin/true || exit 1
  269.  
  270.         # now gather all the binutils in one place on the hypervisor's filesystem and name them appropriately
  271.         test -e "${CURRENT_DIR}/binutils-build" || mkdir -p "${CURRENT_DIR}/binutils-build"
  272.         rm "${CURRENT_DIR}/binutils-build/${TARGET_TRIPLE}-"* 2>/dev/null
  273.         VERSION="$(grep PACKAGE_VERSION opcodes/config.h|awk -F'"' '{print $2}')"
  274.         VERSION_MAJ="$(echo "${VERSION}"|cut -d . -f 1)"; test -z "${VERSION_MAJ}" && VERSION_MAJ="0"
  275.         VERSION_MIN="$(echo "${VERSION}"|cut -d . -f 2)"; test -z "${VERSION_MIN}" && VERSION_MIN="0"
  276.         VERSION_REV="$(echo "${VERSION}"|cut -d . -f 3)"; test -z "${VERSION_REV}" && VERSION_REV="0"
  277.         for TOOL in \
  278.                         binutils/addr2line:addr2line \
  279.                         binutils/ar:ar \
  280.                         gas/as-new:as \
  281.                         binutils/cxxfilt:c++filt \
  282.                         binutils/elfedit:elfedit \
  283.                         gprof/gprof:gprof \
  284.                         ld/ld-new:ld.bfd \
  285.                         binutils/nm-new:nm \
  286.                         binutils/objcopy:objcopy \
  287.                         binutils/objdump:objdump \
  288.                         binutils/ranlib:ranlib \
  289.                         binutils/readelf:readelf \
  290.                         binutils/size:size \
  291.                         binutils/strings:strings \
  292.                         binutils/strip-new:strip \
  293.         ; do
  294.                 SRC="$(echo "${TOOL}"|cut -d : -f 1)"
  295.                 TGT="$(echo "${TOOL}"|cut -d : -f 2)"
  296.                 cp "${SRC}" "${CURRENT_DIR}/binutils-build/${TARGET_TRIPLE}-${TGT}-${VERSION_MAJ}.${VERSION_MIN}.${VERSION_REV}" || exit 1
  297.         done
  298.  
  299.         # return to the sources dir and proceed to the next arch
  300.         cd ../..
  301. done
  302.  
  303. /bin/printf "\n\xf0\x9f\x8d\xba\x20\x43\x68\x65\x65\x72\x73\x2e\n"
  304. exit 0
  305.